# PA165/03 24. Smart Energy Management System

*PA165 course at MUNI Spring 2022.*

# About Project

- **Name**: Smart Energy Management System
- **Developers**:
    - 485025, Aneta Čadová
    - 485432, Daniela Hostačná
    - 485418, Tomáš Ondruško
    - 493364, Timotej Šulík
- **Assigment**:
    - The system will allow users to manage the smart meter devices at home. For a user, it will be possible to set different smart meters for the different houses they own/rent, and track the power consumption statistics over time that is collected automatically. They can track the power consumption of different devices in different time of the day (e.g., at night). They can also shut down the power to one of their houses through the system, when power is not needed. The power distribution company can consult the power consumption statistics over period of times of all the users registered into the system.
    
## **How to run the app**

### **Prerequisities**
- Make sure your Java is set to `version 11`
- Install Node.js (example for Fedora: `dnf install npm`)

### **Running the app**
- Move to the root of the project
- Compile sources and run tests using `mvn clean install`
- Move to the sems-react directory and run `npm install`
- Run the app using `npm start`
- Instructions how to run and test the application backend are in the `sems-rest/README.md` 
- It has been agreed upon with the lecturer to use two ports.
# Project Description

Smart Energy Management System is a simple system for users who want to manage smart meter devices possibly in multiple households.

### Entities

- **User** - entity representing a user of the system
- **House** - entity representing a house owned/managed by a user
- **Device** - entity representing a smart energy consumption meter such as the one which can be plugged into a power outlet 
- **Consumption Event** - entity representing an event of a device sending measurement data into the system

### Roles

System has two authorization roles - **User** and **Distributor**.
In our system, one user account can have only one of these roles. As such, a distribution company worker cannot track their smart meters under a work account. 

- **User** - the role of a basic user - such user can see their own data: houses, devices, profile...
- **Distributor** - the role of an employee account from within an energy distribution company - such workers should be able to see aggregated statistics

### Other Enums
- **PowerStatus** - enum representing whether the device/smart meter is turned on or off
- **Gender** - enum representing user's gender

# Diagrams

![UseCase Diagram](diagrams/UCD.png)

---

![Class Diagram](diagrams/CD.png)
