package cz.muni.fi.pa165.project.facade;

import cz.muni.fi.pa165.project.dto.DeviceAssignHouseDTO;
import cz.muni.fi.pa165.project.dto.DeviceCreateDTO;
import cz.muni.fi.pa165.project.dto.DeviceDetailConsumptionEventDTO;
import cz.muni.fi.pa165.project.dto.DeviceDetailDTO;
import cz.muni.fi.pa165.project.dto.DeviceListDTO;
import cz.muni.fi.pa165.project.dto.DeviceUpdateDTO;
import org.springframework.data.domain.Page;
import org.springframework.data.domain.Pageable;

public interface DeviceFacade {

    Page<DeviceListDTO> getDevicesByUser(String loggedInUsername, Pageable pageable);

    DeviceDetailDTO getDevice(String loggedInUsername, long deviceId);

    void updateDevice(String loggedInUsername, long deviceId, DeviceUpdateDTO house);

    Long createDevice(String loggedInUsername, DeviceCreateDTO device);

    Page<DeviceDetailConsumptionEventDTO> getConsumptionEventsByDevice(String loggedInUsername, long deviceId, Pageable pageable);

    long assignDeviceToHouse(String loggedInUsername, long deviceId, long houseId);

    void unAssignDeviceFromHouse(String loggedInUsername, long deviceId, long houseId);

    void deleteDevice(String loggedInUsername, long deviceId);
}
