package cz.muni.fi.pa165.project.facade;

import cz.muni.fi.pa165.project.dto.HouseCreateDTO;
import cz.muni.fi.pa165.project.dto.HouseDetailConsumptionEventDTO;
import cz.muni.fi.pa165.project.dto.HouseDetailDTO;
import cz.muni.fi.pa165.project.dto.HouseDetailDeviceDTO;
import cz.muni.fi.pa165.project.dto.HouseListDTO;
import cz.muni.fi.pa165.project.dto.HouseUpdateDetailDTO;
import org.springframework.data.domain.Page;
import org.springframework.data.domain.Pageable;

public interface HouseFacade {

    Page<HouseListDTO> getHousesByUser(String loggedInUsername, Pageable pageable);

    HouseDetailDTO getHouseDetail(String loggedInUsername, long houseId);

    void updateHouse(String loggedInUsername, long houseId, HouseUpdateDetailDTO house);

    void deleteHouse(String loggedInUsername, long houseId);

    void shutDown(String loggedInUsername, long houseId);

    long createHouse(String loggedInUsername, HouseCreateDTO house);

    Page<HouseDetailDeviceDTO> getDevicesByHouse(String loggedInUsername, long houseId, Pageable pageable);

    Page<HouseDetailConsumptionEventDTO> getConsumptionEventsByHouse(String loggedInUsername, long houseId, Pageable pageable);
}
