package cz.muni.fi.pa165.project.repository;

import cz.muni.fi.pa165.project.entity.ConsumptionEvent;
import cz.muni.fi.pa165.project.entity.Device;
import org.springframework.data.domain.Page;
import org.springframework.data.domain.Pageable;
import org.springframework.data.jpa.repository.JpaRepository;
import org.springframework.data.jpa.repository.Modifying;
import org.springframework.data.jpa.repository.Query;
import org.springframework.data.repository.query.Param;

import java.util.List;

/**
 * @author Tomáš Ondruško | 485418
 */
public interface ConsumptionEventRepository extends JpaRepository<ConsumptionEvent, Long> {

    @Query("SELECT e FROM ConsumptionEvent e WHERE e.device.id IN :ids")
    Page<ConsumptionEvent> findAllByDeviceIds(@Param("ids") List<Long> ids, Pageable pageable);

    @Query("SELECT e FROM ConsumptionEvent e WHERE e.device = :device")
    Page<ConsumptionEvent> findAllByDevice(@Param("device") Device device, Pageable page);

    @Modifying
    @Query("DELETE FROM ConsumptionEvent e WHERE e.device.id IN :ids")
    void deleteAllByDeviceIds(@Param("ids") List<Long> ids);
}
