package cz.muni.fi.pa165.project.repository;

import cz.muni.fi.pa165.project.entity.AppUser;
import cz.muni.fi.pa165.project.entity.Device;
import org.springframework.data.domain.Page;
import org.springframework.data.domain.Pageable;
import org.springframework.data.jpa.repository.JpaRepository;
import org.springframework.data.jpa.repository.Query;
import org.springframework.data.repository.query.Param;

import java.util.List;

/**
 * @author Daniela Hostačná | 485432
 */
public interface DeviceRepository extends JpaRepository<Device, Long> {
    @Query("SELECT d FROM Device d WHERE d.id IN :ids")
    Page<Device> findAllByIds(@Param("ids") List<Long> ids, Pageable pageable);

    @Query("SELECT d FROM Device d WHERE d.owner = :user")
    Page<Device> findAllByUser(@Param("user") AppUser user, Pageable pageable);
}
