package cz.muni.fi.pa165.project.repository;

import cz.muni.fi.pa165.project.entity.Device;
import cz.muni.fi.pa165.project.entity.House;
import cz.muni.fi.pa165.project.entity.HouseDevice;
import org.springframework.data.jpa.repository.JpaRepository;
import org.springframework.data.jpa.repository.Query;
import org.springframework.data.repository.query.Param;

import java.util.List;

/**
 * @author Daniela Hostačná | 485432
 */
public interface HouseDeviceRepository extends JpaRepository<HouseDevice, Long> {
    @Query("SELECT hd FROM HouseDevice hd WHERE hd.device = :device AND hd.house = :house AND hd.validTo IS NULL")
    List<HouseDevice> findOpenByDeviceAndHouse(@Param("device") Device device, @Param("house") House house);
}
