import axios from 'axios';
import React from 'react';
import BackButton from '../BackButton';

interface ICreateDeviceProps {

}

interface ICreateDeviceState {
    nickname: string;
    model: string;
}

export default class CreateDevice extends React.Component<ICreateDeviceProps, ICreateDeviceState> {
    constructor(props: ICreateDeviceProps) {
        super(props);
        this.state = {
            nickname: "",
            model: ""
        }

        this.handleSubmit = this.handleSubmit.bind(this);
    }

    handleSubmit(event: any) {
        axios.post("/me/devices",
            JSON.stringify(
                {
                    nickname: event.target.nickname.value,
                    model: event.target.model.value
                }
            ),
            {
                headers: {
                    "Content-Type": "application/json",
                    "authorization": `${sessionStorage.getItem("token")}`
                }
            }
        );
    }

    render() {
        return (
            <div>
                {BackButton("/devices")}
                <div>
                    <h2 className="heading">Add new device</h2>
                    <form onSubmit={this.handleSubmit} className="custom_form">
                        <label>Nickname: </label>
                        <input type="text" name="nickname" required /><br />
                        <label>Model: </label>
                        <input type="text" name="model" required /><br />
                        <input className="stylized_button button_color" type="submit" value="Submit" id="submit" />
                    </form>
                </div>
            </div>
        );
    }
}
