import axios from 'axios';
import React from 'react';
import BackButton from '../BackButton';

interface ICreateHouseProps {

}

interface ICreateHouseState {
    name: string;
    street: string;
    city: string;
    zipCode: string;
    country: string;
}

export default class CreateHouse extends React.Component<ICreateHouseProps, ICreateHouseState> {
    constructor(props: ICreateHouseProps) {
        super(props);
        this.state = {
            name: "",
            street: "",
            city: "",
            zipCode: "",
            country: ""
        }

        this.handleSubmit = this.handleSubmit.bind(this);
    }

    handleSubmit(event: any) {
        axios.post("/me/houses",
            JSON.stringify(
                {
                    name: event.target.name.value,
                    street: event.target.street.value,
                    city: event.target.city.value,
                    zipCode: event.target.zipCode.value,
                    country: event.target.country.value
                }
            ),
            {
                headers: {
                    "Content-Type": "application/json",
                    "authorization": `${sessionStorage.getItem("token")}`
                }
            }
        );
    }

    render() {
        return (
            <div>
                {BackButton("/houses")}
                <div>
                    <h2 className="heading">Add new house</h2>
                    <form onSubmit={this.handleSubmit} className="custom_form">
                        <label>Name: </label>
                        <input type="text" name="name" required /><br />
                        <label>Street: </label>
                        <input type="text" name="street" required /><br />
                        <label>City: </label>
                        <input type="text" name="city" required /><br />
                        <label>ZIP Code: </label>
                        <input type="text" name="zipCode" required /><br />
                        <label>Country: </label>
                        <input type="text" name="country" required /><br />
                        <input className="stylized_button button_color" type="submit" value="Submit" id="submit" />
                    </form>
                </div>
            </div>
        );
    }
}
