import axios from "axios";
import React from "react";
import BackButton from "../BackButton";

interface IChangePasswordProps {

}

interface IChangePasswordState {
    changed: boolean;
    error: string;
}

export default class ChangePassword extends React.Component<IChangePasswordProps, IChangePasswordState> {
    constructor(props: IChangePasswordProps) {
        super(props);
        this.state = {
            changed: false,
            error: ""
        }

        this.handleSubmit = this.handleSubmit.bind(this);
    }

    handleSubmit(event: any) {
        var oldPwd = event.target.currentPwd.value;
        var newPwd = event.target.newPwd.value;
        var newPwdAgain = event.target.confirmNewPwd.value
        event.preventDefault();

        axios.put("/users/current/password",
            JSON.stringify(
                {
                    oldPassword: oldPwd,
                    newPassword: newPwd,
                    newPasswordAgain: newPwdAgain
                }
            ),
            {
                headers: {
                    "Content-Type": "application/json",
                    "authorization": `${sessionStorage.getItem("token")}`
                }
            }
        ).then(() => {
            this.setState({
                changed: true
            })
        }).catch((error) => {
            if (newPwd !== newPwdAgain) {
                this.setState({ error: "New passwords do not match" });
            } else {
                this.setState({ error: "Current password is incorrect" });
            }
        });
    }

    render() {
        const { changed } = this.state;
        if (changed) {
            window.location.href = "/profile";
        }
        return (
            <div>
                {BackButton("/profile")}
                <div className="error_msg" style={{ color: "red" }}>{this.state.error}</div>
                <h2 className="heading">Change password</h2>
                <form onSubmit={this.handleSubmit} className="custom_form">
                    <label>Current password: </label>
                    <input type="password" name="currentPwd" required /><br />
                    <label>New password: </label>
                    <input type="password" name="newPwd" required /><br />
                    <label>Confirm new password: </label>
                    <input type="password" name="confirmNewPwd" required /><br />
                    <input className="stylized_button button_color" type="submit" value="Change password" id="submit" />
                </form>
            </div>
        );
    }
}
