# Test REST API using the Swagger UI

## Set up the data
We use sample data from ``pa165-smart-energy-management-system/sems-rest/src/main/resources/data.sql``. You can manage the data by editing this script, or using the H2 database console on [http://localhost:8081/h2-console/](http://localhost:8081/h2-console/). You need to run the application to access the database console (See the next step).

Credentials from the app properties (``pa165-smart-energy-management-system/sems-rest/src/main/resources/application.properties``): 
- JDBC URL - jdbc:h2:mem:sems-db
- user name - root
- password - root


## Set up testing

Go to the rest module and run the application.

```bash
cd pa165-smart-energy-management-system/sems-rest
mvn spring-boot:run
```
Open the Swagger on [http://localhost:8081/pa165/rest/swagger-ui/](http://localhost:8081/pa165/rest/swagger-ui/)

## Login and authentication
Firstly, we need to check the login. 
 1. Scroll down to Authentication and click on the POST login.
 2. Click on the “Try it out” button.
 3. Enter credentials for a basic user.
     - email: user@mail.com
     - password: password
 4. Click on the “Execute” button.
 5. Check that the response code is 200.
 6. Go to the response headers and copy the bearer token. Example:

```bash
authorization: Bearer eyJhbGciOiJIUzUxMiJ9.eyJzdWIiOiJ1c2VyQG1haWwuY29tIiwiaWF0IjoxNjUyNzE0MTQ3LCJleHAiOjE2NTMzMTg5NDd9.n9Gr-__z9P5nL5MzvPMyDbxnf6EpYSDjO4jiqxnP-T9DVBwnouSTdBZuNLJWWgQZtdr7bC8qrLd0rehxkm-tLg 
```

7. Click on the “Authorize” button on the top right corner of the Swagger page.
8. Paste the bearer token and click on the “authorize” button. Copy the token carefully - the token is quite long, and usually is split into more lines. Also, check that you did not copy whitespaces.
8. Now the user is authenticated.


## Test other requests
Now you can test other requests for basic users. 
1. Select any request and click on the “Try it out” button.
2. Set up the request.
  - For some GET requests (e.g GET /me/devices) you need to set up pagination.
     - page param - can be 0
     - size param - Set the size to the number of results which you want to get here. We usually have 20-30 records for each table, I recommend using 30 as the size param. 
     - sort param - set sorting param, e.g id
for some requests, you need to specify the request body or parameters. (e.g id parameter for GET by id requests, request body for a POST request,... )

3. Click on the “Execute” button and check the response.


