package cz.muni.fi.pa165.project.config;

import cz.muni.fi.pa165.project.dto.DeviceDetailDTO;
import cz.muni.fi.pa165.project.dto.DeviceDetailHouseDTO;
import cz.muni.fi.pa165.project.entity.Device;
import cz.muni.fi.pa165.project.entity.House;
import org.mapstruct.Mapper;
import org.mapstruct.factory.Mappers;

/**
 * @author Daniela Hostačná | 485432
 */
@Mapper(componentModel = "spring")
public interface DeviceDetailMapper {
    default DeviceDetailDTO map(Device source) {
        if (source == null) {
            return null;
        }

        var assignedHouseDevice = source.getHouseDevices().stream()
                .filter(houseDevice -> houseDevice.getValidTo() == null)
                .findFirst()
                .orElse(null);

        PowerStatusEnumMapper powerStatusEnumMapper = Mappers.getMapper(PowerStatusEnumMapper.class);

        return new DeviceDetailDTO(
                source.getId() == null ? 0L : source.getId(),
                source.getNickName(),
                source.getModel(),
                powerStatusEnumMapper.map(source.getPowerStatus()),
                assignedHouseDevice == null ? null : map(assignedHouseDevice.getHouse())
        );
    }

    DeviceDetailHouseDTO map(House source);
}
