package cz.muni.fi.pa165.project.config;

import cz.muni.fi.pa165.project.dto.DistributorConsumptionEventListDTO;
import cz.muni.fi.pa165.project.entity.ConsumptionEvent;
import org.mapstruct.Mapper;
import org.springframework.data.domain.Page;

/**
 * @author Daniela Hostačná | 485432
 */
@Mapper(componentModel = "spring")
public interface DistributorConsumptionEventListMapper {
    default DistributorConsumptionEventListDTO map(ConsumptionEvent source) {
        if (source == null) {
            return null;
        }

        return new DistributorConsumptionEventListDTO(
                source.getId() == null ? 0L : source.getId(),
                source.getTimestamp(),
                source.getPowerConsumption(),
                source.getDevice().getOwner().getFirstName().concat(" ").concat(source.getDevice().getOwner().getLastName())
        );
    }

    default Page<DistributorConsumptionEventListDTO> map(Page<ConsumptionEvent> source) {
        return source.map(this::map);
    }
}
