package cz.muni.fi.pa165.project.config;

import cz.muni.fi.pa165.project.dto.HouseListDTO;
import cz.muni.fi.pa165.project.entity.House;
import org.mapstruct.Mapper;
import org.springframework.data.domain.Page;

/**
 * @author Daniela Hostačná | 485432
 */
@Mapper(componentModel = "spring")
public interface HouseListMapper {
    default HouseListDTO map(House source) {
        if (source == null) {
            return null;
        }

        return new HouseListDTO(
                source.getId() == null ? 0L : source.getId(),
                source.getName(),
                source.getStreet(),
                source.getCity(),
                source.getZip(),
                source.getCountry(),
                source.getHouseDevices().stream()
                        .filter(houseDevice -> houseDevice.getValidTo() == null)
                        .toArray()
                        .length
        );
    }

    default Page<HouseListDTO> map(Page<House> source) {
        if (source == null) {
            return null;
        }

        return source.map(this::map);
    }
}
