package cz.muni.fi.pa165.project.facade;

import cz.muni.fi.pa165.project.config.DistributorConsumptionEventListMapper;
import cz.muni.fi.pa165.project.dto.DistributorConsumptionEventListDTO;
import cz.muni.fi.pa165.project.service.AppUserService;
import cz.muni.fi.pa165.project.service.ConsumptionEventService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.data.domain.Page;
import org.springframework.data.domain.Pageable;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

/**
 * @author Daniela Hostačná | 485432
 */
@Service
@Transactional
public class ConsumptionEventFacadeImpl implements ConsumptionEventFacade {

    private final ConsumptionEventService consumptionEventService;

    private final AppUserService appUserService;

    private final DistributorConsumptionEventListMapper mapper;

    @Autowired
    public ConsumptionEventFacadeImpl(ConsumptionEventService consumptionEventService, AppUserService appUserService, DistributorConsumptionEventListMapper mapper) {
        this.consumptionEventService = consumptionEventService;
        this.appUserService = appUserService;
        this.mapper = mapper;
    }

    @Override
    public Page<DistributorConsumptionEventListDTO> getAll(Pageable pageable) {
        return mapper.map(consumptionEventService.findAll(pageable));
    }
}
