package cz.muni.fi.pa165.project.service;

import cz.muni.fi.pa165.project.entity.ConsumptionEvent;
import cz.muni.fi.pa165.project.entity.Device;
import cz.muni.fi.pa165.project.repository.ConsumptionEventRepository;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.data.domain.Page;
import org.springframework.data.domain.Pageable;
import org.springframework.stereotype.Service;

import java.util.List;

/**
 * @author Daniela Hostačná | 485432
 */
@Service
public class ConsumptionEventServiceImpl implements ConsumptionEventService {

    private final ConsumptionEventRepository consumptionEventRepository;

    @Autowired
    public ConsumptionEventServiceImpl(ConsumptionEventRepository consumptionEventRepository) {
        this.consumptionEventRepository = consumptionEventRepository;
    }

    @Override
    public Page<ConsumptionEvent> findAll(Pageable page) {
        return consumptionEventRepository.findAll(page);
    }

    @Override
    public Page<ConsumptionEvent> findConsumptionEventsForDevices(List<Long> deviceIds, Pageable page) {
        return consumptionEventRepository.findAllByDeviceIds(deviceIds, page);
    }

    @Override
    public void deleteAllByDeviceIds(List<Long> deviceIds) {
        consumptionEventRepository.deleteAllByDeviceIds(deviceIds);
    }

    @Override
    public Page<ConsumptionEvent> findConsumptionEventsForDevice(Device device, Pageable page) {
        return consumptionEventRepository.findAllByDevice(device, page);
    }
}
