package cz.muni.fi.pa165.project.service;

import cz.muni.fi.pa165.project.entity.AppUser;
import cz.muni.fi.pa165.project.entity.Device;
import org.springframework.data.domain.Page;
import org.springframework.data.domain.Pageable;

import java.util.List;

/**
 * @author Daniela Hostačná | 485432
 */
public interface DeviceService {
    void deleteAllForUser(AppUser user);

    void shutDownAllDevicesByIds(List<Long> ids);

    Page<Device> findDevicesByIds(List<Long> ids, Pageable page);

    Page<Device> findDevicesForUser(AppUser user, Pageable page);

    Device findById(long deviceId);

    Long create(Device device);

    void update(Device device);

    void delete(Device device);
}
