package cz.muni.fi.pa165.project.service;

import cz.muni.fi.pa165.project.repository.AppUserRepository;
import cz.muni.fi.pa165.project.util.UserHelper;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.security.core.authority.SimpleGrantedAuthority;
import org.springframework.security.core.userdetails.UserDetails;
import org.springframework.security.core.userdetails.UserDetailsService;
import org.springframework.security.core.userdetails.UsernameNotFoundException;
import org.springframework.stereotype.Service;

import java.util.Collections;

@Service
public class UsersDetailServiceImpl implements UserDetailsService {
    private final AppUserRepository appUserRepository;

    @Autowired
    public UsersDetailServiceImpl(AppUserRepository appUserRepository) {
        this.appUserRepository = appUserRepository;
    }

    @Override
    public UserDetails loadUserByUsername(String username) throws UsernameNotFoundException {
        try {
            var userEntity = appUserRepository.findByEmail(username);
            return new UserHelper(
                    userEntity.getEmail(),
                    userEntity.getPasswordHash(),
                    Collections.singletonList(new SimpleGrantedAuthority(userEntity.getRole().toString().toUpperCase())));
        } catch (Exception e) {
            e.printStackTrace();
            throw new UsernameNotFoundException("User " + username + " was not found in the database");
        }
    }
}
