package cz.muni.fi.pa165.project.config;

import cz.muni.fi.pa165.project.BaseServiceLayerTest;
import cz.muni.fi.pa165.project.dto.DeviceCreateDTO;
import cz.muni.fi.pa165.project.entity.Device;
import cz.muni.fi.pa165.project.enums.PowerStatus;
import org.junit.jupiter.api.Test;
import org.springframework.beans.factory.annotation.Autowired;

import static org.assertj.core.api.Assertions.assertThat;

/**
 * @author Aneta Čadová | 485025
 */
class DeviceCreateMapperTest extends BaseServiceLayerTest {
    @Autowired
    DeviceCreateMapper deviceCreateMapper;

    @Test
    void mapDeviceToDeviceCreateDTOTest() {
        Device device = new Device(null, "nickName", "model", PowerStatus.OFF);

        DeviceCreateDTO deviceCreateDTO = deviceCreateMapper.map(device);

        assertThat(deviceCreateDTO).isNotNull();
        assertThat(deviceCreateDTO.getModel()).isEqualTo(device.getModel());
        assertThat(deviceCreateDTO.getNickname()).isEqualTo(device.getNickName());
    }

    @Test
    void mapDeviceCreateToDeviceDTOTest() {
        DeviceCreateDTO deviceCreateDTO = new DeviceCreateDTO("nickName", "model");
        Device device = deviceCreateMapper.map(deviceCreateDTO);

        assertThat(device).isNotNull();
        assertThat(device.getModel()).isEqualTo(deviceCreateDTO.getModel());
        assertThat(device.getNickName()).isEqualTo(deviceCreateDTO.getNickname());
    }
}
