package cz.muni.fi.pa165.project.config;

import cz.muni.fi.pa165.project.BaseServiceLayerTest;
import cz.muni.fi.pa165.project.enums.Gender;
import cz.muni.fi.pa165.project.enums.GenderDto;
import org.junit.jupiter.api.Test;
import org.springframework.beans.factory.annotation.Autowired;

import static org.assertj.core.api.Assertions.assertThat;

/**
 * @author Aneta Čadová | 485025
 */
class GenderEnumMapperTest extends BaseServiceLayerTest {
    @Autowired
    GenderEnumMapper genderEnumMapper;

    @Test
    void mapGenderToGenderDtoTest() {
        Gender gender = Gender.FEMALE;

        GenderDto genderDto = genderEnumMapper.map(gender);

        assertThat(genderDto).isNotNull();
        assertThat(genderDto.name()).isEqualTo(gender.name());
    }

    @Test
    void mapGenderDtoToGenderTest() {
        GenderDto genderDto = GenderDto.FEMALE;

        Gender gender = genderEnumMapper.map(genderDto);

        assertThat(gender).isNotNull();
        assertThat(gender.name()).isEqualTo(genderDto.name());
    }

}
