package cz.muni.fi.pa165.project.config;

import cz.muni.fi.pa165.project.BaseServiceLayerTest;
import cz.muni.fi.pa165.project.dto.HouseCreateDTO;
import cz.muni.fi.pa165.project.entity.AppUser;
import cz.muni.fi.pa165.project.entity.House;
import cz.muni.fi.pa165.project.enums.Gender;
import cz.muni.fi.pa165.project.enums.UserRole;
import org.junit.jupiter.api.Test;
import org.springframework.beans.factory.annotation.Autowired;

import static org.assertj.core.api.Assertions.assertThat;

/**
 * @author Aneta Čadová | 485025
 */
class HouseCreateMapperTest extends BaseServiceLayerTest {
    @Autowired
    HouseCreateMapper houseCreateMapper;

    @Test
    void mapHouseToHouseCreateDTOTest() {
        AppUser user = new AppUser("email", "hash", "firstName", "lastName", "123456789", Gender.FEMALE, UserRole.APP_USER);
        House house = new House(user, "FI MUNI", "Botanicka 68A", "Brno", "zip", "country");

        HouseCreateDTO houseCreateDTO = houseCreateMapper.map(house);

        assertThat(houseCreateDTO).isNotNull();
        assertThat(houseCreateDTO.getName()).isEqualTo(house.getName());
        assertThat(houseCreateDTO.getStreet()).isEqualTo(house.getStreet());
        assertThat(houseCreateDTO.getCity()).isEqualTo(house.getCity());
        assertThat(houseCreateDTO.getZipCode()).isEqualTo(house.getZip());
        assertThat(houseCreateDTO.getCountry()).isEqualTo(house.getCountry());
    }

    @Test
    void mapDeviceCreateToDeviceDTOTest() {
        HouseCreateDTO houseCreateDTO = new HouseCreateDTO("FI MUNI", "Botanicka 68A", "Brno", "zip", "country");
        House house = houseCreateMapper.map(houseCreateDTO);

        assertThat(house).isNotNull();
        assertThat(house.getName()).isEqualTo(houseCreateDTO.getName());
        assertThat(house.getStreet()).isEqualTo(houseCreateDTO.getStreet());
        assertThat(house.getCity()).isEqualTo(houseCreateDTO.getCity());
        assertThat(house.getZip()).isEqualTo(houseCreateDTO.getZipCode());
        assertThat(house.getCountry()).isEqualTo(houseCreateDTO.getCountry());
    }
}
