package cz.muni.fi.pa165.project.config;

import cz.muni.fi.pa165.project.BaseServiceLayerTest;
import cz.muni.fi.pa165.project.dto.HouseDetailDeviceDTO;
import cz.muni.fi.pa165.project.entity.Device;
import cz.muni.fi.pa165.project.enums.PowerStatus;
import cz.muni.fi.pa165.project.enums.PowerStatusDto;
import org.junit.jupiter.api.Test;
import org.springframework.beans.factory.annotation.Autowired;

import static org.assertj.core.api.Assertions.assertThat;

/**
 * @author Aneta Čadová | 485025
 */
class HouseDetailDeviceMapperTest extends BaseServiceLayerTest {

    @Autowired
    HouseDetailDeviceMapper houseDetailDeviceMapper;

    @Test
    void mapDeviceToHouseDetailDeviceDTOTest() {
        Device device = new Device(null, "nickName", "model", PowerStatus.OFF);

        HouseDetailDeviceDTO houseDetailDeviceDto = houseDetailDeviceMapper.map(device);

        assertThat(houseDetailDeviceDto).isNotNull();
        assertThat(houseDetailDeviceDto.getId()).isEqualTo(0L);
        assertThat(houseDetailDeviceDto.getModel()).isEqualTo(device.getModel());
        assertThat(houseDetailDeviceDto.getNickname()).isEqualTo(device.getNickName());
        assertThat(houseDetailDeviceDto.getPowerStatus()).isEqualTo(PowerStatusDto.OFF);
    }
}
