package cz.muni.fi.pa165.project.config;

import cz.muni.fi.pa165.project.BaseServiceLayerTest;
import cz.muni.fi.pa165.project.dto.HouseDetailDTO;
import cz.muni.fi.pa165.project.entity.AppUser;
import cz.muni.fi.pa165.project.entity.House;
import cz.muni.fi.pa165.project.enums.Gender;
import cz.muni.fi.pa165.project.enums.UserRole;
import org.junit.jupiter.api.Test;
import org.springframework.beans.factory.annotation.Autowired;

import static org.assertj.core.api.Assertions.assertThat;

/**
 * @author Daniela Hostačná | 485432
 */
class HouseDetailMapperTest extends BaseServiceLayerTest {
    @Autowired
    private HouseDetailMapper houseDetailMapper;

    @Test
    void mapHouseToHouseDetailDtoTest() {
        AppUser user = new AppUser("email", "hash", "firstName", "lastName", "123456789", Gender.FEMALE, UserRole.APP_USER);
        House house = new House(user, "FI MUNI", "Brno", "CZ", "Botanicka 68A", "60200");

        HouseDetailDTO houseDetailDTO = houseDetailMapper.map(house);

        assertThat(houseDetailDTO).isNotNull();
        assertThat(houseDetailDTO.getId()).isEqualTo(0L);
        assertThat(houseDetailDTO.getName()).isEqualTo(house.getName());
        assertThat(houseDetailDTO.getCountry()).isEqualTo(house.getCountry());
    }
}