package cz.muni.fi.pa165.project.config;

import cz.muni.fi.pa165.project.BaseServiceLayerTest;
import cz.muni.fi.pa165.project.dto.HouseUpdateDetailDTO;
import cz.muni.fi.pa165.project.entity.AppUser;
import cz.muni.fi.pa165.project.entity.House;
import cz.muni.fi.pa165.project.enums.Gender;
import cz.muni.fi.pa165.project.enums.UserRole;
import org.junit.jupiter.api.Test;
import org.springframework.beans.factory.annotation.Autowired;

import static org.assertj.core.api.Assertions.assertThat;

/**
 * @author Aneta Čadová | 485025
 */
class HouseUpdateDetailMapperTest extends BaseServiceLayerTest {
    @Autowired
    HouseUpdateDetailMapper houseUpdateDetailMapper;


    @Test
    void mapHouseToHouseUpdateDetailDTOTest() {
        AppUser user = new AppUser("email", "hash", "firstName", "lastName", "123456789", Gender.FEMALE, UserRole.APP_USER);
        House house = new House(user, "FI MUNI", "Botanicka 68A", "Brno", "zip", "country");

        HouseUpdateDetailDTO houseUpdateDetailDTO = houseUpdateDetailMapper.map(house);

        assertThat(houseUpdateDetailDTO).isNotNull();
        assertThat(houseUpdateDetailDTO.getName()).isEqualTo(house.getName());
        assertThat(houseUpdateDetailDTO.getStreet()).isEqualTo(house.getStreet());
        assertThat(houseUpdateDetailDTO.getCity()).isEqualTo(house.getCity());
        assertThat(houseUpdateDetailDTO.getZipCode()).isEqualTo(house.getZip());
        assertThat(houseUpdateDetailDTO.getCountry()).isEqualTo(house.getCountry());
    }

    @Test
    void mapHouseUpdateDetailToHouseTest() {
        HouseUpdateDetailDTO houseUpdateDetailDTO = new HouseUpdateDetailDTO("FI MUNI", "", "", "zip", "country");
        House house = houseUpdateDetailMapper.map(houseUpdateDetailDTO);

        assertThat(house).isNotNull();
        assertThat(house.getName()).isEqualTo(houseUpdateDetailDTO.getName());
        assertThat(house.getStreet()).isEqualTo(houseUpdateDetailDTO.getStreet());
        assertThat(house.getCity()).isEqualTo(houseUpdateDetailDTO.getCity());
        assertThat(house.getZip()).isEqualTo(houseUpdateDetailDTO.getZipCode());
        assertThat(house.getCountry()).isEqualTo(houseUpdateDetailDTO.getCountry());
    }

}
