package cz.muni.fi.pa165.project.config;

import cz.muni.fi.pa165.project.BaseServiceLayerTest;
import cz.muni.fi.pa165.project.enums.PowerStatus;
import cz.muni.fi.pa165.project.enums.PowerStatusDto;
import org.junit.jupiter.api.Test;
import org.springframework.beans.factory.annotation.Autowired;

import static org.assertj.core.api.Assertions.assertThat;

/**
 * @author Aneta Čadová | 485025
 */
class PowerStatusEnumMapperTest extends BaseServiceLayerTest {

    @Autowired
    PowerStatusEnumMapper powerStatusEnumMapper;

    @Test
    void mapPowerStatusToPowerStatusDtoTest() {
        PowerStatus status = PowerStatus.OFF;

        PowerStatusDto powerStatusDto = powerStatusEnumMapper.map(status);

        assertThat(powerStatusDto).isNotNull();
        assertThat(powerStatusDto.name()).isEqualTo(status.name());
    }

    @Test
    void mapPowerStatusDtoToPowerStatusTest() {
        PowerStatusDto powerStatusDto = PowerStatusDto.OFF;

        PowerStatus powerStatus = powerStatusEnumMapper.map(powerStatusDto);
        assertThat(powerStatus).isNotNull();
        assertThat(powerStatus.name()).isEqualTo(powerStatusDto.name());
    }
}
