package cz.muni.fi.pa165.project.config;

import cz.muni.fi.pa165.project.BaseServiceLayerTest;
import cz.muni.fi.pa165.project.dto.UserProfileDTO;
import cz.muni.fi.pa165.project.entity.AppUser;
import cz.muni.fi.pa165.project.enums.Gender;
import cz.muni.fi.pa165.project.enums.GenderDto;
import cz.muni.fi.pa165.project.enums.UserRole;
import org.junit.jupiter.api.Test;
import org.springframework.beans.factory.annotation.Autowired;

import static org.assertj.core.api.Assertions.assertThat;

/**
 * @author Aneta Čadová | 485025
 */
class UserProfileMapperTest extends BaseServiceLayerTest {
    @Autowired
    UserProfileMapper userProfileMapper;


    @Test
    void mapUserToUserProfileDTOTest() {
        AppUser user = new AppUser("email", "hash", "firstName", "lastName", "123456789", Gender.FEMALE, UserRole.APP_USER);

        UserProfileDTO userProfileDto = userProfileMapper.map(user);

        assertThat(userProfileDto).isNotNull();
        assertThat(userProfileDto.getEmail()).isEqualTo(user.getEmail());
        assertThat(userProfileDto.getFirstName()).isEqualTo(user.getFirstName());
        assertThat(userProfileDto.getLastName()).isEqualTo(user.getLastName());
        assertThat(userProfileDto.getGender()).isEqualTo(GenderDto.FEMALE);
        assertThat(userProfileDto.getPhoneNumber()).isEqualTo(user.getPhoneNumber());
    }

    @Test
    void mapUserProfileDTOToUserTest() {
        UserProfileDTO userProfileDTO = new UserProfileDTO(GenderDto.FEMALE, "firstName", "lastName", "123456789", "email");

        AppUser appUser = userProfileMapper.map(userProfileDTO);

        assertThat(appUser).isNotNull();
        assertThat(appUser.getEmail()).isEqualTo(userProfileDTO.getEmail());
        assertThat(appUser.getFirstName()).isEqualTo(userProfileDTO.getFirstName());
        assertThat(appUser.getLastName()).isEqualTo(userProfileDTO.getLastName());
        assertThat(appUser.getGender()).isEqualTo(Gender.FEMALE);
        assertThat(appUser.getPhoneNumber()).isEqualTo(userProfileDTO.getPhoneNumber());
    }
}
