package cz.muni.fi.pa165.project.config;

import cz.muni.fi.pa165.project.BaseServiceLayerTest;
import cz.muni.fi.pa165.project.enums.UserRole;
import cz.muni.fi.pa165.project.enums.UserRoleDto;
import org.junit.jupiter.api.Test;
import org.springframework.beans.factory.annotation.Autowired;

import static org.assertj.core.api.Assertions.assertThat;

/**
 * @author Aneta Čadová | 485025
 */
class UserRoleEnumMapperTest extends BaseServiceLayerTest {
    @Autowired
    UserRoleEnumMapper userRoleEnumMapper;

    @Test
    void mapUserRoleToUserRoleDtoTest() {
        UserRole role = UserRole.APP_USER;

        UserRoleDto userRoleDto = userRoleEnumMapper.map(role);

        assertThat(userRoleDto).isNotNull();
        assertThat(userRoleDto.name()).isEqualTo(role.name());
    }

    @Test
    void mapUserRoleDtoToUserRoleTest() {
        UserRoleDto userRoleDto = UserRoleDto.APP_USER;

        UserRole userRole = userRoleEnumMapper.map(userRoleDto);

        assertThat(userRole).isNotNull();
        assertThat(userRole.name()).isEqualTo(userRoleDto.name());
    }
}
