package cz.muni.fi.pa165.project.config;

import cz.muni.fi.pa165.project.BaseServiceLayerTest;
import cz.muni.fi.pa165.project.dto.UserUpdateDTO;
import cz.muni.fi.pa165.project.entity.AppUser;
import cz.muni.fi.pa165.project.enums.Gender;
import cz.muni.fi.pa165.project.enums.GenderDto;
import cz.muni.fi.pa165.project.enums.UserRole;
import org.junit.jupiter.api.Test;
import org.springframework.beans.factory.annotation.Autowired;

import static org.assertj.core.api.Assertions.assertThat;

/**
 * @author Aneta Čadová | 485025
 */
class UserUpdateMapperTest extends BaseServiceLayerTest {

    @Autowired
    UserUpdateMapper userUpdateMapper;

    @Test
    void mapUserToUserUpdateDTOTest() {
        AppUser user = new AppUser("email", "hash", "firstName", "lastName", "123456789", Gender.FEMALE, UserRole.APP_USER);

        UserUpdateDTO userUpdateDTO = userUpdateMapper.map(user);

        assertThat(userUpdateDTO).isNotNull();
        assertThat(userUpdateDTO.getFirstName()).isEqualTo(user.getFirstName());
        assertThat(userUpdateDTO.getLastName()).isEqualTo(user.getLastName());
        assertThat(userUpdateDTO.getGender()).isEqualTo(GenderDto.FEMALE);
        assertThat(userUpdateDTO.getPhoneNumber()).isEqualTo(user.getPhoneNumber());
    }

    @Test
    void mapUserUpdateDTOToUserTest() {
        UserUpdateDTO userUpdateDTO = new UserUpdateDTO(GenderDto.FEMALE, "firstName", "lastName", "123456789");

        AppUser appUser = userUpdateMapper.map(userUpdateDTO);

        assertThat(appUser).isNotNull();
        assertThat(appUser.getFirstName()).isEqualTo(userUpdateDTO.getFirstName());
        assertThat(appUser.getLastName()).isEqualTo(userUpdateDTO.getLastName());
        assertThat(appUser.getGender()).isEqualTo(Gender.FEMALE);
        assertThat(appUser.getPhoneNumber()).isEqualTo(userUpdateDTO.getPhoneNumber());
    }

}
